package com.example.example3;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity {

	private static final String STATUS_KEY = "status";
	private static final String COUNTRY_KEY = "country";
	private static final String IP_KEY = "query";
	public static final String CHANGE_BUTTON_TEXT_KEY = "ChangeButtonText";
	private TextView statusCode, country, ipAddress;
	private Button gotoNextActivity;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		statusCode = (TextView)findViewById(R.id.statusCode);
		country = (TextView)findViewById(R.id.country);
		ipAddress = (TextView)findViewById(R.id.ipAddress);
		gotoNextActivity = (Button)findViewById(R.id.gotoNextActivity );
		
		Bundle bundle = getIntent().getExtras();
		String showButtonText = bundle.getString(CHANGE_BUTTON_TEXT_KEY);
		gotoNextActivity.setText(showButtonText);
		
		new Thread(new Runnable(){
	         @Override
	          public void run() {

	        	 JSONObject jObj = queryData("http://ip-api.com/json");
	        	 parseAndFillData(jObj);
	         }
		}).start();
	}
	
	private JSONObject queryData(String URL){
		// Network access
        HttpClient lClient = new DefaultHttpClient();
        HttpGet lGetMethod = new HttpGet(URL);
        HttpResponse lResp = null;
        try {
			lResp = lClient.execute(lGetMethod);
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
        if(lResp==null) return null;
        
        // Read JSON data from http response
        ByteArrayOutputStream lBOS = new ByteArrayOutputStream();
        String lInfoStr = null;
        JSONObject jSONObjResponse = null;
        try {
			lResp.getEntity().writeTo(lBOS);
			lInfoStr = lBOS.toString("UTF-8");
			jSONObjResponse = new JSONObject(lInfoStr);
		}catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        return jSONObjResponse;
    }

	private void parseAndFillData(final JSONObject jObj){
		runOnUiThread(new Runnable(){
			@Override
			public void run() {
				String sts=null, ctry=null, ip=null;
				
				if(jObj == null) return;
		        // parse JSONObject
				try {
					sts = jObj.getString(STATUS_KEY);
					ctry = jObj.getString(COUNTRY_KEY);
					ip = jObj.getString(IP_KEY);
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				//show parse data on TextView
				if(statusCode!=null)
					statusCode.setText(sts);
				if(country!=null)
					country.setText(ctry);
				if(ipAddress!=null)
					ipAddress.setText(ip);
			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
