package com.example.example3;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity3 extends Activity {

	private static final String STATUS_KEY = "status";
	private static final String COUNTRY_KEY = "country";
	private static final String IP_KEY = "query";
	public static final String CHANGE_BUTTON_TEXT_KEY = "ChangeButtonText";
	private TextView statusCode, country, ipAddress;
	private Button gotoNextActivity;
	private MainReciever mainReciever;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		statusCode = (TextView) findViewById(R.id.statusCode);
		country = (TextView) findViewById(R.id.country);
		ipAddress = (TextView) findViewById(R.id.ipAddress);

		// Start Service with intent
		Intent intent = new Intent(this, MainService.class);
		intent.putExtra(MainService.URL_KEY, "http://ip-api.com/json");
		startService(intent);
		// Register Reciever
		mainReciever = new MainReciever(this);
		registerReceiver(mainReciever, new IntentFilter(
				MainService.NOTIFICATION));

        gotoNextActivity = (Button)findViewById(R.id.gotoNextActivity );
        gotoNextActivity .setOnClickListener(new Button.OnClickListener(){
           @Override
            public void onClick(View v) {
               Intent intent = new Intent();
               intent.setClass(MainActivity3.this, MainActivity2.class);
               startActivity(intent);
            } 
        });
	}

	@Override
	protected void onDestroy() {
		// Unregister Reciever
		unregisterReceiver(mainReciever);
		super.onDestroy();
	}

	public void parseAndFillData(JSONObject jObj) {
		String sts = null, ctry = null, ip = null;

		if (jObj == null)
			return;
		// parse JSONObject
		try {
			sts = jObj.getString(STATUS_KEY);
			ctry = jObj.getString(COUNTRY_KEY);
			ip = jObj.getString(IP_KEY);
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// show parse data on TextView
		if (statusCode != null)
			statusCode.setText(sts);
		if (country != null)
			country.setText(ctry);
		if (ipAddress != null)
			ipAddress.setText(ip);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
