package com.example.example3;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.IntentService;
import android.content.Intent;

public class MainService extends IntentService {

	public static final String URL_KEY = "URL";
	public static final String NOTIFICATION = "com.example.example2.MainReciever";
	public MainService() {
		super("MainService");
	}

	@Override
	protected void onHandleIntent(Intent intent) {
		 // function called when someone call StartService(intent)
        String url = intent.getExtras().getString(URL_KEY);
        JSONObject jObj = queryData(url);
        publishResults(jObj.toString());
	}
	private void publishResults(String result) {
        // broadcast message
        Intent intent = new Intent(NOTIFICATION);
        intent.putExtra(MainReciever.JSONSTRING_KEY, result);
        sendBroadcast(intent);
    }
	
	private JSONObject queryData(String URL){
		// Network access
        HttpClient lClient = new DefaultHttpClient();
        HttpGet lGetMethod = new HttpGet(URL);
        HttpResponse lResp = null;
        try {
			lResp = lClient.execute(lGetMethod);
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
        if(lResp==null) return null;
        
        // Read JSON data from http response
        ByteArrayOutputStream lBOS = new ByteArrayOutputStream();
        String lInfoStr = null;
        JSONObject jSONObjResponse = null;
        try {
			lResp.getEntity().writeTo(lBOS);
			lInfoStr = lBOS.toString("UTF-8");
			jSONObjResponse = new JSONObject(lInfoStr);
		}catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        return jSONObjResponse;
    }

}
